import threading
import time
from lib.controller import *
from lib.display import *
from lib.line import *
from lib.log import *
from lib.motor import *
from lib.rgbcolorsensor import *
from lib.rgbcolorsensorutil import *
from lib.servo import *
from lib.txt40 import *

started = None
text = None
delay_sec = None


def thread_display():
    global started, text, delay_sec
    display.set_attr("txt_button_start.enabled", str(True).lower())
    while True:
        display.set_attr("txt_label_text.text", str(text))
        time.sleep(0.2)


def on_txt_button_start_clicked(event):
    global started, text, delay_sec
    started = True


display.button_clicked("txt_button_start", on_txt_button_start_clicked)


init_log(20)
init_calib_sensors()
init_calib_motor()
init_calib_servo()
init_rgbcolorsensor()
init_rgbcolorsensorutil()
started = False
delay_sec = 1
text = 'Initialization'
threading.Thread(target=thread_display, daemon=True).start()
print('battery:{}V soc: {}%'.format(get_battery(), get_soc()))
print('rgbw: {}'.format(get_rgbcolorsensor_color0_RGBW()))
while True:
    text = 'Ready'
    while True:
        if started:
            break
        time.sleep(0.010)
    text = 'RUN'
    calib_line_rotate360()
    while started:
        turn_sync(90)
        servo_down()
        while True:
            pass


