import math
import time
from lib.controller import *

pos = None
s1_pos_target = None
s1_min = None
s1_pos = None
s1_max = None
s1_step = None
i = None
s1_home = None


def init_calib_servo():
    global pos, s1_pos_target, s1_min, s1_pos, s1_max, s1_step, i, s1_home
    s1_min = 180
    s1_max = 480
    s1_step = 1
    s1_home = s1_min
    TXT_M_S1_servomotor.set_position(int(s1_home))
    s1_pos = s1_home


def get_s1_pos():
    global pos, s1_pos_target, s1_min, s1_pos, s1_max, s1_step, i, s1_home
    return s1_pos


def servo(pos):
    global s1_pos_target, s1_min, s1_pos, s1_max, s1_step, i, s1_home
    servo_move_wait(pos)


def servo_up():
    global pos, s1_pos_target, s1_min, s1_pos, s1_max, s1_step, i, s1_home
    servo_move_wait(s1_min)


def servo_down():
    global pos, s1_pos_target, s1_min, s1_pos, s1_max, s1_step, i, s1_home
    servo_move_wait(s1_max)


def servo_move_wait(s1_pos_target):
    global pos, s1_min, s1_pos, s1_max, s1_step, i, s1_home
    print('  servo_move_wait target:{} from pos:{}'.format(s1_pos_target, s1_pos))
    if s1_pos != s1_pos_target:
        for i in (s1_pos <= s1_pos_target) and upRange(s1_pos, s1_pos_target, s1_step) or downRange(s1_pos, s1_pos_target, s1_step):
            TXT_M_S1_servomotor.set_position(int(min(max(i, s1_min), s1_max)))
            time.sleep(0.001)
        TXT_M_S1_servomotor.set_position(int(min(max(s1_pos_target, s1_min), s1_max)))
        s1_pos = round(s1_pos_target)


def upRange(start, stop, step):
    while start <= stop:
        yield start
        start += abs(step)
def downRange(start, stop, step):
    while start >= stop:
        yield start
        start -= abs(step)
